package com.xx.xxviewlibrary.base;

import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.view.Display;
import android.view.LayoutInflater;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;

import androidx.annotation.NonNull;
import androidx.databinding.DataBindingUtil;
import androidx.databinding.ViewDataBinding;

import com.xx.xxviewlibrary.R;


public abstract class xxBaseDialog<T extends ViewDataBinding> extends Dialog {
    DialogSet set;
   public T binding;

   public onDialogClickListener  DialogClickListener;

   public static int KEY_CONFIRM=1001;

    public xxBaseDialog(@NonNull Context context) {
        super(context, R.style.DialogTheme);
        set = InitView();
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding= DataBindingUtil.inflate(LayoutInflater.from(getContext()),
                set.getLayout(),
                null,
                false);
        setContentView(binding.getRoot());
        setCanceledOnTouchOutside(set.isOutSite());
        setCancelable(set.isCancle());
        getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        getWindow().getDecorView().setPadding(0, 0, 0, 0);
//        window.setAttributes(params);
        getWindow().setLayout(set.width, set.hight);
        InitData();
       int i= View.GONE;

    }

    public abstract DialogSet InitView();

    public abstract void InitData();

    public class DialogSet {
        int layout;
        boolean outSite;
        int gravity;
        boolean cancle;
        int width;
        int hight;
        int animStyle;
        // 参数分别为1.布局文件 2.点击外部是否能取消 3.布局对齐格式 4.触发返回键是否能取消
        public DialogSet(int layout, boolean outSide, int gravity, boolean cancle) {
            this.layout = layout;
            this.outSite = outSide;
            this.gravity = gravity;
            this.cancle = cancle;
            this.width = WindowManager.LayoutParams.WRAP_CONTENT;
            this.hight = WindowManager.LayoutParams.WRAP_CONTENT;
        }

        public DialogSet(int layout, boolean outSide, int gravity, boolean cancle, int w, int h) {
            this.layout = layout;
            this.outSite = outSide;
            this.gravity = gravity;
            this.cancle = cancle;
            this.width = w;
            this.hight = h;
        }

        public int getWidth() {
            return width;
        }

        public void setWidth(int width) {
            this.width = width;
        }

        public int getHight() {
            return hight;
        }

        public void setHight(int hight) {
            this.hight = hight;
        }

        public int getAnimStyle() {
            return animStyle;
        }

        public void setAnimStyle(int animStyle) {
            this.animStyle = animStyle;
        }

        public boolean isCancle() {
            return cancle;
        }

        public void setCancle(boolean cancle) {
            this.cancle = cancle;
        }

        public int getLayout() {
            return layout;
        }

        public void setLayout(int layout) {
            this.layout = layout;
        }

        public boolean isOutSite() {
            return outSite;
        }

        public void setOutSite(boolean outSite) {
            this.outSite = outSite;
        }

        public int getGravity() {
            return gravity;
        }

        public void setGravity(int gravity) {
            this.gravity = gravity;
        }
    }

    @Override
    public void show() {
        Window window = getWindow();
        //设置弹出位置
        window.setGravity(set.getGravity());

//        window.setBackgroundDrawableResource(android.R.color.white);

        //设置弹出动画
        if (set.animStyle!=0)
        {
            window.setWindowAnimations(set.animStyle);
        }

        //设置对话框大小
//        WindowManager.LayoutParams params = getWindow().getAttributes();
//        params.width = WindowManager.LayoutParams.MATCH_PARENT;
//        params.height = WindowManager.LayoutParams.WRAP_CONTENT;
        window.setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        window.getDecorView().setPadding(0, 0, 0, 0);
//        window.setAttributes(params);
//        window.setLayout(WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.WRAP_CONTENT);
        Display display =window.getWindowManager().getDefaultDisplay();
        DisplayMetrics metrics = new DisplayMetrics();
        int height = display.getHeight();
        WindowManager wm = (WindowManager) getContext().getSystemService(Context.WINDOW_SERVICE);

        wm.getDefaultDisplay().getMetrics(metrics);

        if (metrics.heightPixels < height/5*4) {
            window.setLayout(WindowManager.LayoutParams.WRAP_CONTENT, WindowManager.LayoutParams.WRAP_CONTENT);

        } else {
            window.setLayout(WindowManager.LayoutParams.WRAP_CONTENT, height/5*4);

        }

        super.show();
    }


    public void clickDialog(View view)
    {
        if (DialogClickListener!=null)
        {
            DialogClickListener.dialogClickBack(view.getId(),null);
        }
    }


    public void setDialogClickListener(onDialogClickListener  mDialogClickListener )
    {
        DialogClickListener=mDialogClickListener;
    }


     public interface onDialogClickListener<K>{

        public void dialogClickBack(int code,K data);
    }

}
