package com.xx.xxviewlibrary.base;

import android.Manifest;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.databinding.ViewDataBinding;
import androidx.fragment.app.FragmentActivity;
import androidx.lifecycle.LifecycleOwner;
import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.RecyclerView;

import com.huantansheng.easyphotos.EasyPhotos;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.huantansheng.easyphotos.models.album.entity.Photo;
import com.tbruyelle.rxpermissions3.RxPermissions;
import com.xx.xxviewlibrary.comm.CommTextDialog;
import com.xx.xxviewlibrary.comm.RefuseDialogBean;
import com.xx.xxviewlibrary.utils.GlideEngine;
import com.xx.xxviewlibrary.witget.model.FileBean;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;


public abstract class xxBaseRecyclerViewAdapter<T extends ViewDataBinding,K> extends RecyclerView.Adapter<xxBaseRecyclerViewViewHolder<T>> {

    public Context mContext;
    public List<K> mList;
    public LifecycleOwner ownerl;

    public OnItemClick<K> itemClick;



    public xxBaseRecyclerViewAdapter(Context context) {
        try{
            ownerl= (LifecycleOwner) context;
        }catch (Exception e)
        {

        }

        mContext=context;
    }

    @NonNull
    @Override
    public xxBaseRecyclerViewViewHolder<T> onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view= LayoutInflater.from(mContext).inflate(initLayout(),parent,false);

        return new xxBaseRecyclerViewViewHolder<T>(mContext,view);
    }

    @Override
    public void onBindViewHolder(@NonNull xxBaseRecyclerViewViewHolder<T> holder,  int position) {



        covert(holder.dataBind,mList.get(position),position);
        if (itemClick!=null)
        {

        holder.dataBind.getRoot().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                    itemClick.itemClickCalBack(position,mList.get(position));
                }

        });
    }

    }



    @Override
    public int getItemCount() {
        return mList==null?0:mList.size();
    }

    public abstract int initLayout();


    protected abstract void covert(T dataBind, K data, int position);



    public void startPhoto(boolean hasCamera,String pmsg,SelectCallback callback)
    {

        RxPermissions rp=new RxPermissions((FragmentActivity) AppManager.getAppManager().currentActivity());

        if ( !rp.isGranted(Manifest.permission.CAMERA) || !rp.isGranted(Manifest.permission.READ_EXTERNAL_STORAGE))
        {

            CommTextDialog textDialog = new CommTextDialog(mContext,new RefuseDialogBean(pmsg, "同意", "拒绝"), new CommTextDialog.onAcceptCallBack() {
                @Override
                public void acceptBack() {
                    EasyPhotos.createAlbum(AppManager.getAppManager().currentActivity(), hasCamera, false, GlideEngine.getInstance()).setCount(1)
                            .start(callback);
                }

                @Override
                public void refuseBack() {


                }
            });
            textDialog.show();
        }else {
            EasyPhotos.createAlbum(AppManager.getAppManager().currentActivity(), hasCamera, false, GlideEngine.getInstance()).setCount(1)
                    .start(callback);
        }

    }

    public void  setOnItemClick(OnItemClick<K> click )
    {
        itemClick=click;
    }


    public interface OnItemClick<K>
    {
        void itemClickCalBack(int position,K data);
    }


}
