package com.xx.xxviewlibrary.base;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.databinding.ViewDataBinding;
import androidx.recyclerview.widget.RecyclerView;

import com.huantansheng.easyphotos.EasyPhotos;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.xx.xxviewlibrary.utils.GlideEngine;

import java.util.List;


public abstract class xxBaseRecyclerViewWithViewModelAdapter<T extends ViewDataBinding,K> extends RecyclerView.Adapter<xxBaseRecyclerViewViewHolder<T>> {

    public Context mContext;
    public List<K> mList;

    public xxBaseRecyclerViewWithViewModelAdapter(Context context) {
        mContext=context;
    }

    @NonNull
    @Override
    public xxBaseRecyclerViewViewHolder<T> onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view= LayoutInflater.from(mContext).inflate(initLayout(),parent,false);
        return new xxBaseRecyclerViewViewHolder<T>(mContext,view);
    }

    @Override
    public void onBindViewHolder(@NonNull xxBaseRecyclerViewViewHolder<T> holder, int position) {

        covert(holder.dataBind,mList.get(position),position);
    }



    @Override
    public int getItemCount() {
        return mList.size();
    }

    public abstract int initLayout();


    protected abstract void covert(T dataBind, K data, int position);

    public void startPhoto(boolean hasCamera, SelectCallback callback)
    {
        EasyPhotos.createAlbum(AppManager.getAppManager().currentActivity(), hasCamera, false, GlideEngine.getInstance()).setCount(1)
                .start(callback);
    }
}
