package com.xx.xxviewlibrary.comm

import android.content.Context
import android.os.Bundle
import android.util.Log
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import android.webkit.WebView
import android.webkit.WebViewClient
import com.xx.xxviewlibrary.base.xxBaseDialog
import com.xx.xxviewlibrary.databinding.DialogCommTextAgreeBinding
import me.jessyan.autosize.utils.AutoSizeUtils


class CommTextAgreeDialog(
    context: Context,
    var bean: RefuseDialogBean,
    var callback: onAcceptCallBack
) :
    xxBaseDialog<DialogCommTextAgreeBinding>(context) {
    var dismissBack: Boolean = true;
    override fun InitView(): DialogSet {
        val screenHeight = context.resources.displayMetrics.heightPixels
        val dialogHeight = (screenHeight * 0.8).toInt() // 设置对话框高度为屏幕高度的80%
        return DialogSet(
            com.xx.xxviewlibrary.R.layout.dialog_comm_text_agree,
            false,
            Gravity.CENTER_HORIZONTAL or Gravity.CENTER_VERTICAL,
            true,
            AutoSizeUtils.dp2px(context, 285.0F),

            dialogHeight
        )

    }

    override fun InitData() {
        binding.model = bean
        binding.dialog = this

        // bean.main是一个字符串类型的URL
        val beanMain: String? = bean.main
        // 从字符串中获取URL
        val urlRegex = "URL=(.*?),".toRegex()
        val matchResult = urlRegex.find(beanMain ?: "")
        val url = matchResult?.groupValues?.get(1)
        // http://49.232.201.130:7005/api/app/agreement/getContent/8
        Log.v("打印隐私条款地址", url.toString())

        //获得控件
        val webView = findViewById<View>(binding.webComm.id) as WebView
        //访问网页

        webView.settings.javaScriptEnabled = true // 启用JavaScript

        webView.loadUrl(url.toString())
        //设置WebView客户端
        webView.webViewClient = object : WebViewClient() {
            override fun shouldOverrideUrlLoading(view: WebView, url: String): Boolean {
                //使用WebView加载显示url
                view.loadUrl(url)
                //返回true
                return true
            }
        }


        /*关闭弹窗监听事件,使其手机返回上一级功能和取消功能一致*/
        setOnDismissListener {
            if (dismissBack) {
                /*调用取消功能*/
                callback.refuseBack()
            }
        }
    }

    /*重写返回按钮*/
    override fun onBackPressed() {
        /*不做任何作用*/
        callback.refuseBack()
    }
    fun refuseClick(view: View) {
        callback.refuseBack()
        dismissBack = false
        dismiss()
    }

    fun acceptClick(view: View) {
        callback.acceptBack()
        dismissBack = false
        dismiss()
    }

    interface onAcceptCallBack {
        fun acceptBack()
        fun refuseBack()
    }

}
