package com.xx.xxviewlibrary.comm

import android.content.Context
import android.content.DialogInterface
import android.text.TextUtils
import android.view.Gravity
import android.view.View
import android.view.WindowManager
import com.xx.xxviewlibrary.R
import com.xx.xxviewlibrary.base.xxBaseDialog
import com.xx.xxviewlibrary.databinding.DialogCommTextBinding
import me.jessyan.autosize.utils.AutoSizeUtils

class CommTextDialog(context: Context, var bean: RefuseDialogBean, var callback: onAcceptCallBack) :
    xxBaseDialog<DialogCommTextBinding>(context) {
    var dismissBack: Boolean = true;
    override fun InitView(): DialogSet {
        return DialogSet(
            R.layout.dialog_comm_text,
            false,
            Gravity.CENTER_HORIZONTAL or Gravity.CENTER_VERTICAL,
            true,
            AutoSizeUtils.dp2px(context, 285.0F),
            WindowManager.LayoutParams.WRAP_CONTENT
        )
    }

    override fun InitData() {
        binding.model = bean
        binding.dialog = this
        /*关闭弹窗监听事件,使其手机返回上一级功能和取消功能一致*/
        setOnDismissListener {
            if (dismissBack) {
                /*调用取消功能*/
                callback.refuseBack()
            }
        }

        /*  if (TextUtils.isEmpty(bean.refuseTxt))
          {
              binding.btnRefuse.visibility=View.GONE
          }*/

    }

    fun refuseClick(view: View) {
        callback.refuseBack()
        dismissBack = false
        dismiss()
    }

    fun acceptClick(view: View) {
        callback.acceptBack()
        dismissBack = false
        dismiss()
    }

    interface onAcceptCallBack {
        fun acceptBack()
        fun refuseBack()
    }
}
