package com.xx.xxviewlibrary.utils

import android.content.Context
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.text.SpannableStringBuilder
import android.text.style.AbsoluteSizeSpan
import com.xx.xxviewlibrary.model.DictBean
import java.math.BigDecimal
import java.text.NumberFormat
import java.text.SimpleDateFormat
import java.util.Arrays


fun priceSTrUtils(price: Double): SpannableStringBuilder {

    var sb: SpannableStringBuilder = SpannableStringBuilder("￥")

    var nb: NumberFormat = NumberFormat.getInstance();
    nb.isGroupingUsed = true
    var intPart: String = nb.format(price.toLong())

    //小数点位
    val bg = BigDecimal(price - price.toLong())
    val f1: Double = bg.setScale(2, BigDecimal.ROUND_HALF_UP).toDouble()
    var doublePart: String
    if (f1 == 0.0) {
        doublePart = ".00"
    } else {
        if (f1 < 0.1) {
            doublePart = ".0" + (f1 * 100).toLong().toString()
        } else {
            doublePart = "." + (f1 * 100).toLong().toString()
        }

    }



    sb.append(intPart, AbsoluteSizeSpan(18, true), intPart.length)
    sb.append(doublePart, AbsoluteSizeSpan(12, true), doublePart.length)


    return sb
}


/**
 * 保留两位小数
 */
fun priceScale(price: Double): String {
    val formattedPrice = String.format("%.2f", price)
    return formattedPrice
}


fun getVersion(context: Context): String {
    val manager: PackageManager = context.getPackageManager()
    val info: PackageInfo = manager.getPackageInfo(context.getPackageName(), 0)
    return info.versionName
}

fun getTimeForm(time: String): String {
    val df = SimpleDateFormat("yyyy-MM-dd HH:mm:ss")
    val date = df.parse(time);
    val df2 = SimpleDateFormat("yyyy-MM-dd")
    return df2.format(date)
}

fun getDictMap(list: List<DictBean>): Map<String, String>? {
    val map: MutableMap<String, String> = HashMap()
    for (bean in list) {
        map[bean.dictValue] = bean.dictLabel
    }
    return map
}


fun checkVersionUpdata(self: String, line: String): Boolean {
    var selfs: List<String> = self.split(".")
    var lines: List<String> = line.split(".")

    for (i in 0 until 3) {

        if (lines.get(i).toInt() > selfs.get(i).toInt()) {
            return true
        }else if (lines.get(i).toInt() < selfs.get(i).toInt()){
            return false
        }
    }

    return false

}
