package com.xx.xxviewlibrary.witget

import android.content.Context
import android.content.res.TypedArray
import android.graphics.drawable.Drawable
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageButton
import android.widget.ImageView
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.databinding.BindingAdapter
import androidx.databinding.InverseBindingAdapter
import androidx.databinding.InverseBindingListener
import com.xx.xxviewlibrary.R

/**
 * 自定义titlebar
 */
class XxBar  constructor(activity: Context?, attrs: AttributeSet?) : RelativeLayout(activity, attrs, ){
    //标题
    @JvmField
    var tv_title: TextView? = null
    //左侧icon
    var img_left: ImageButton? = null

    //右侧icon
    var img_right: ImageView? = null

    var attrsArray:TypedArray?= null


    init {
        InitView(attrs)
    }



    companion object
    {

        @BindingAdapter("bar_title")
        @JvmStatic
        fun setBarTitle(view: XxBar, title:String)
        {
            view.tv_title?: return
            view.tv_title?.setText(title)
        }


        @InverseBindingAdapter(attribute ="bar_title")
        @JvmStatic
        fun getBarTitle(view: XxBar):String
        {
            return view.tv_title?.text.toString()
        }

        @BindingAdapter("bar_titleAttrChanged")
        @JvmStatic fun setListeners(
            view: XxBar,
            attrChange: InverseBindingListener
        ) {

        }



        @BindingAdapter("on_click")
        @JvmStatic
        fun setOnCLick(view: XxBar, click:View.OnClickListener)
        {
            view.img_left?: return
            view.img_left?.setOnClickListener(click)
        }

        @BindingAdapter("right_src")
        @JvmStatic
        fun setRightSrc(view: XxBar, res:Drawable?)
        {

            view.img_right?: return
            if(res==null)
            {
                view.img_right?.visibility=View.GONE
            }else{
                view.img_right?.visibility=View.VISIBLE
                view.img_right?.setImageDrawable(res)
            }

        }


        @BindingAdapter("right_click")
        @JvmStatic
        fun setRightClick(view: XxBar, click:View.OnClickListener)
        {
            view.img_right?: return
            view.img_right?.setOnClickListener(click)
        }

    }



    fun InitView(attrs: AttributeSet?) {
        val view: View = LayoutInflater.from(context).inflate(R.layout.witget_bar, this, true)
        tv_title = view.findViewById<TextView>(R.id.bar_title)
        img_left = view.findViewById<ImageButton>(R.id.bar_left_icon)

        img_right=view.findViewById<ImageView>(R.id.iv_bar_right)


    }


    fun setRightSrc( res:Drawable?)
    {

        img_right?: return
        if(res==null)
        {
           img_right?.visibility=View.GONE
        }else{
            img_right?.visibility=View.VISIBLE
            img_right?.setImageDrawable(res)
        }

    }


}