package com.xx.xxviewlibrary.witget

import android.content.Context
import android.content.res.TypedArray
import android.text.Editable
import android.text.InputFilter
import android.text.InputType
import android.text.TextUtils
import android.text.TextWatcher
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.EditText
import android.widget.ImageView
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.databinding.BindingAdapter
import androidx.databinding.InverseBindingAdapter
import androidx.databinding.InverseBindingListener
import com.xx.xxviewlibrary.R


class XxFormEdit  constructor(context: Context?, attrs: AttributeSet?) : ConstraintLayout(context!!, attrs ) {
    //标题
    var tv_title: TextView? = null

    //输入
    var et_content: EditText? = null

    //输入多行
    var et_contents: EditText? = null

    //底部线条
    var v_line: View? = null

    //必填标识
    var tv_necessary: TextView? = null

    //问题内容
    var tv_content: TextView? = null

    //问题内容
    var tv_contents: TextView? = null

    //选择图标
    var iv_select: ImageView? = null

    var contentType: Int = 0



    private var onInputChangeListener: InverseBindingListener? = null

    init {
        InitView(attrs)
    }


    /**
     * ed_title 标题
     * ed_content 输入内容
     */
    companion object {

        @BindingAdapter("ed_title")
        @JvmStatic
        fun setEdTitle(view: XxFormEdit, title: String) {
            view.tv_title ?: return
            view.tv_title?.setText(title)
        }


        @InverseBindingAdapter(attribute = "ed_title")
        @JvmStatic
        fun getEdTitle(view: XxFormEdit): String {
            return view.tv_title?.text.toString()
        }

        @BindingAdapter("ed_titleAttrChanged")
        @JvmStatic
        fun setListeners(
            view: XxFormEdit,
            attrChange: InverseBindingListener
        ) {

        }


        @BindingAdapter("ed_content")
        @JvmStatic
        fun setEdContent(view: XxFormEdit, title: String?) {

            if (title == null) {
                return
            }
            if (view.contentType == 0) {
                view.et_content ?: return
                if (view.et_content?.text?.toString().equals(title) == false) {
                    view.et_content!!.setText(title)
                }
            } else if (view.contentType == 1 || view.contentType == 2) {
                view.tv_content ?: return
                if (view.tv_content?.text?.toString().equals(title) == false) {
                    view.tv_content!!.setText(title)
                }
            } else if (view.contentType == 3) {
                view.et_contents ?: return
                if (view.et_contents?.text?.toString().equals(title) == false) {
                    view.et_contents!!.setText(title)
                }
            }else if(view.contentType == 4)
            {
                view.tv_contents ?: return
                if (view.tv_contents?.text?.toString().equals(title) == false) {
                    view.tv_contents!!.setText(title)
                }
            }
        }


        @InverseBindingAdapter(attribute = "ed_content")
        @JvmStatic
        fun getEdContent(view: XxFormEdit): String {
            if (view.contentType == 0) {
                return view.et_content?.text.toString()
            } else if (view.contentType == 3) {
                return view.et_contents?.text.toString()
            }
            return ""

        }

        @BindingAdapter("ed_contentAttrChanged")
        @JvmStatic
        fun setEditContentListeners(
            view: XxFormEdit,
            attrChange: InverseBindingListener
        ) {
            view.onInputChangeListener = attrChange

        }
    }


    fun InitView(attrs: AttributeSet?) {
        val view: View = LayoutInflater.from(context).inflate(R.layout.witget_xx_edit, this, true)
        tv_title = view.findViewById<TextView>(R.id.tv_wxe_title)
        tv_content = view.findViewById<TextView>(R.id.tv_wxe_content)
        et_content = view.findViewById<EditText>(R.id.et_wxe_content)
        et_contents = view.findViewById<EditText>(R.id.et_wxe_contents)
        v_line = view.findViewById(R.id.v_wxe_line)
        tv_necessary = view.findViewById(R.id.tv_wxe_necessary)
        tv_contents=view.findViewById(R.id.tv_wxe_contents)
        iv_select = view.findViewById<ImageView>(R.id.iv_wxe_select)

        if(attrs!=null)
        {
        var typedArray: TypedArray =
            context.obtainStyledAttributes(attrs, R.styleable.xxFormEditStyle)


            //是否底部控件
        if (typedArray.getBoolean(R.styleable.xxFormEditStyle_isBottom, false)) {
            v_line?.visibility = GONE
        } else {
            v_line?.visibility = VISIBLE
        }


            //是否必填
        if (typedArray.getBoolean(R.styleable.xxFormEditStyle_necessary, true)) {
            tv_necessary?.visibility = VISIBLE
        } else {
            tv_necessary?.visibility = GONE
        }

            if (typedArray.getInteger(R.styleable.xxFormEditStyle_max_length,0)!=0) {
                et_content?.filters = arrayOf<InputFilter>(
                    InputFilter.LengthFilter(typedArray.getInteger(R.styleable.xxFormEditStyle_max_length,0)) // 150 is max length
                )

                et_contents?.filters = arrayOf<InputFilter>(
                    InputFilter.LengthFilter(typedArray.getInteger(R.styleable.xxFormEditStyle_max_length,0)) // 150 is max length
                )
            }

        contentType = typedArray.getInteger(R.styleable.xxFormEditStyle_content_type, 0)
        if (contentType == 0) {
            //输入类型
            et_content?.visibility = VISIBLE
            tv_content?.visibility = GONE
            iv_select?.visibility = GONE
            et_contents?.visibility = GONE
            tv_contents?.visibility = GONE
           et_content?.inputType=typedArray.getInt(R.styleable.xxFormEditStyle_inputType,
                InputType.TYPE_CLASS_TEXT or InputType.TYPE_NUMBER_FLAG_DECIMAL)

            et_content?.addTextChangedListener(object : TextWatcher {
                override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

                }

                override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                    onInputChangeListener?.onChange()
                }

                override fun afterTextChanged(p0: Editable?) {

                }

            })
            if (TextUtils.isEmpty(typedArray.getString(R.styleable.xxFormEditStyle_hint_text)) == false) {
                et_content?.hint = typedArray.getString(R.styleable.xxFormEditStyle_hint_text);
            } else {

            }

        } else if (contentType == 1) {
            //文字类型
            et_content?.visibility = GONE
            tv_content?.visibility = VISIBLE
            et_contents?.visibility = GONE
            iv_select?.visibility = GONE
            tv_contents?.visibility = GONE
        } else if (contentType == 2) {
            //选择类型
            et_content?.visibility = GONE
            tv_content?.visibility = VISIBLE
            iv_select?.visibility = VISIBLE
            et_contents?.visibility = GONE
            tv_contents?.visibility = GONE
            tv_content?.text = "请选择"
            tv_content?.setTextColor(context.resources.getColor(R.color.xx_text_hint))

        } else if (contentType == 3) {
            et_content?.visibility = GONE
            tv_content?.visibility = GONE
            iv_select?.visibility = GONE
            et_contents?.visibility = VISIBLE
            tv_contents?.visibility = GONE
            et_contents?.addTextChangedListener(object : TextWatcher {
                override fun beforeTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {

                }

                override fun onTextChanged(p0: CharSequence?, p1: Int, p2: Int, p3: Int) {
                    onInputChangeListener?.onChange()
                }

                override fun afterTextChanged(p0: Editable?) {

                }

            })
            if (TextUtils.isEmpty(typedArray.getString(R.styleable.xxFormEditStyle_hint_text)) == false) {
                et_contents?.hint = typedArray.getString(R.styleable.xxFormEditStyle_hint_text);
            } else {

            }
        } else if(contentType ==4){
            et_content?.visibility = GONE
            tv_content?.visibility = View.GONE
            et_contents?.visibility = GONE
            iv_select?.visibility = GONE
            tv_contents?.visibility = VISIBLE
        }

        }
    }
}


