package com.xx.xxviewlibrary.witget

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.EditText
import android.widget.TextView
import androidx.constraintlayout.widget.ConstraintLayout
import androidx.databinding.BindingAdapter
import androidx.databinding.InverseBindingAdapter
import com.xx.xxviewlibrary.R

class XxFormMsg constructor(context: Context?, attrs: AttributeSet?) : ConstraintLayout(context!!, attrs )  {


    //标题
    var tv_title: TextView? = null

    //输入
    var tv_content: TextView? = null

    init {
        InitView(attrs)
    }

    companion object {

        //设置标题
        @BindingAdapter("xft_title")
        @JvmStatic
        fun setXftTitle(view: XxFormMsg,title:String)
        {
            view.tv_title ?: return
            view.tv_title?.setText(title)

        }

        @InverseBindingAdapter(attribute = "xft_title")
        @JvmStatic
        fun getXftTitle(view: XxFormMsg): String {
            return view.tv_title?.text.toString()
        }


        //设置标题
        @BindingAdapter("xft_content")
        @JvmStatic
        fun setXftContent(view: XxFormMsg,content:CharSequence?)
        {
            view.tv_content ?: return
            content?:return
            view.tv_content?.setText(content)

        }
    }





    fun InitView(attrs: AttributeSet?)
    {
        val view: View = LayoutInflater.from(context).inflate(R.layout.witget_form_text, this, true)
        tv_title=view.findViewById(R.id.tv_xft_title)
        tv_content=view.findViewById(R.id.tv_xft_content)

    }
}