package com.xx.xxviewlibrary.witget

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RelativeLayout
import androidx.databinding.BindingAdapter
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.RoundedCorners
import com.bumptech.glide.request.RequestOptions
import com.xx.xxviewlibrary.R
import com.xx.xxviewlibrary.witget.model.FileBean
import me.jessyan.autosize.utils.AutoSizeUtils

class XxUploudPic(context: Context?, attrs: AttributeSet?) : RelativeLayout(context, attrs) {

    lateinit var iv_content:ImageView;
    lateinit var ll_un_upload:LinearLayout;

    var url:FileBean= FileBean("","")



    companion object {

        @BindingAdapter("pic_url")
        @JvmStatic
        fun setPicUrl(view: XxUploudPic, xurl: FileBean) {
            view.iv_content ?: return
            view.url=xurl;
            if(xurl.path.equals("")==false)
            {
                view.setPic()
            }

        }
    }

    init {
        InitView(attrs)
    }
    fun InitView(attrs: AttributeSet?) {
        val view: View = LayoutInflater.from(context).inflate(R.layout.witget_upload_pic, this, true)
        iv_content=view.findViewById<ImageView>(R.id.iv_wup_content);
        ll_un_upload=view.findViewById<LinearLayout>(R.id.ll_wup_un_upload);
        if (url.path.equals(""))
        {
            iv_content.visibility= GONE
            ll_un_upload.visibility= VISIBLE
        }else{

            setPic()
        }
    }

    fun setPicByUrl(urlStr:FileBean)
    {
        url=urlStr;
        setPic()
    }


    fun setPic()
    {
        iv_content.visibility= VISIBLE
        ll_un_upload.visibility= GONE
        //Glide设置图片圆角角度
        val roundedCorners = RoundedCorners(AutoSizeUtils.dp2px(context,4.00F))
        //通过RequestOptions扩展功能,override:采样率,因为ImageView就这么大,可以压缩图片,降低内存消耗
        // RequestOptions options = RequestOptions.bitmapTransform(roundedCorners).override(20, 20);
        val options = RequestOptions.bitmapTransform(roundedCorners)
        Glide.with(context).load(url.path).apply(options)
            .into(iv_content)
    }


}