package com.xx.xxviewlibrary.witget

import android.content.Context
import android.text.TextUtils
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RelativeLayout
import androidx.databinding.BindingAdapter
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.bitmap.RoundedCorners
import com.bumptech.glide.request.RequestOptions
import com.xx.xxviewlibrary.R
import com.xx.xxviewlibrary.witget.model.FileBean
import me.jessyan.autosize.utils.AutoSizeUtils

class XxUploudPicSmall(context: Context?, attrs: AttributeSet?) : RelativeLayout(context, attrs) {

    lateinit var iv_content:ImageView;
    lateinit var ll_un_upload:LinearLayout;
    lateinit var iv_delete:ImageView;
    var editAble:Boolean=true

    var url:FileBean= FileBean("","")

     var onUploadImgClick: OnUploadImgClick? =null;


    companion object {

        @BindingAdapter("pic_url")
        @JvmStatic
        fun setPicUrl(view: XxUploudPicSmall, xurl: FileBean) {
            view.iv_content ?: return
            view.url=xurl;
            if(xurl.path==null)
            {
                view.iv_content.visibility= GONE
                view.ll_un_upload.visibility= VISIBLE
                view. iv_delete.visibility= GONE
                return
            }
            if(xurl.path.equals("")==false)
            {
                view.setPic()
            }else{
                view.iv_content.visibility= GONE
                view.ll_un_upload.visibility= VISIBLE
                view. iv_delete.visibility= GONE
            }

        }

        @BindingAdapter("editable")
        @JvmStatic
        fun setEditable(view: XxUploudPicSmall, able:Boolean)
        {
            if(view==null) return
            view.editAble=able

        }

    }

    init {
        InitView(attrs)
    }
    fun InitView(attrs: AttributeSet?) {
        val view: View = LayoutInflater.from(context).inflate(R.layout.witget_upload_pic_small, this, true)
        iv_content=view.findViewById<ImageView>(R.id.iv_wup_content);
        ll_un_upload=view.findViewById<LinearLayout>(R.id.ll_wup_un_upload);
        iv_delete=view.findViewById<ImageView>(R.id.iv_aap_delete);
        if (url.path.equals("") ||url.path==null)
        {
            iv_content.visibility= GONE
            ll_un_upload.visibility= VISIBLE
            iv_delete.visibility= GONE
        }else{

            setPic()
        }
        iv_delete.setOnClickListener({
            iv_content.visibility= GONE
            iv_delete.visibility= GONE
            ll_un_upload.visibility= VISIBLE
            url= FileBean("","")
            onUploadImgClick?.delete()
        })
    }

    fun setPicByUrl(urlStr:FileBean)
    {
        url=urlStr;
        setPic()
    }


    fun setPic()
    {
        iv_content.visibility= VISIBLE
        ll_un_upload.visibility= GONE
        if(editAble)
        {
            iv_delete.visibility= VISIBLE
        }else{
            iv_delete.visibility= GONE
        }

        //Glide设置图片圆角角度
        val roundedCorners = RoundedCorners(AutoSizeUtils.dp2px(context,4.00F))
        //通过RequestOptions扩展功能,override:采样率,因为ImageView就这么大,可以压缩图片,降低内存消耗
        // RequestOptions options = RequestOptions.bitmapTransform(roundedCorners).override(20, 20);
        val options = RequestOptions.bitmapTransform(roundedCorners)
        Glide.with(context).load(url.path).apply(options)
            .into(iv_content)
    }



    public fun setEAble(able:Boolean)
    {
        editAble=able
        if (able && !TextUtils.isEmpty(url.path))
        {

            iv_delete.visibility= VISIBLE
        }else{
            iv_delete.visibility= GONE
        }
    }



    interface OnUploadImgClick
    {
        fun delete();
    }



}